#!/usr/bin/env python

import cgi
import dbus
import dbus.glib
#import pygtk
#pygtk.require('2.0')
import curses
import gtk, gobject
import os
import sys
import select
from time import sleep
import thread
import threading, time


import signal

__module_name__ = "bmp-monitor-small"
__module_description__ = "BMPx Python Status Watcher (Small Version)"

prefix = '/usr/local'
class capturekeys( threading.Thread):
	def __init__(self, BMPMonitor):
		threading.Thread.__init__(self)
		
#		c = None
		self.BMPMonitor = BMPMonitor
		
		#if self.BMPMonitor.stdscr == None:
		self.stdscr = curses.initscr()
		self.BMPMonitor.h, self.BMPMonitor.w = self.stdscr.getmaxyx()
		
	def run(self):
		while 1:
			keys = []
		#if 1:
			try:
				c = self.BMPMonitor.stdscr.getkey(self.BMPMonitor.h-3, self.BMPMonitor.edit.x+1)
				keys.append(c)
			except:
				pass

			if not keys:
				d = 1000
			else:
				d = 0

			sleep(0.01)
			while keys:
				
				c, keys = keys[0], keys[1:]
				
				try:
					
					if self.BMPMonitor.edit.process(c):
						line = self.BMPMonitor.edit.line
						#yes = self.BMPMonitor.commands(line)
						yes =1
						if yes == 0:
							break
						elif yes == 2:
							return
						else:
							self.BMPMonitor.edit.clear()
							self.BMPMonitor.edit.reset()
							
							
				except Exception, e:
					print e
				
			#self.BMPMonitor.build(self.BMPMonitor.stdscr, "")
		
class BMPMonitor(capturekeys):
    def __init__(self):
	    
	self.statusText = ''
	self.status=''
	self.title=''
	self.uri = ''
	self.metadata = []
	self.length = 0
	self.stdscr = None
	self.currentTrack = 0
	self.capturekeys = capturekeys(self)
	# Init DBus shizzle
	self.bus = dbus.SessionBus()

	self.bmpx_obj = self.bus.get_object('org.beepmediaplayer.SystemControl', '/org/beepmediaplayer/SystemControl/BmpSystemControl')
	
	self.bmpx = dbus.Interface(self.bmpx_obj, 'org.beepmediaplayer.SystemControl')
	
	#self.bmpx.add_signal_receiver(self.goforit,
	#print self.bmpx.ListNames()
	self.bmpx.connect_to_signal('SetPlaystatus', self.bmpx_set_playstatus)
	self.bmpx.connect_to_signal('SetStreamPos',  self.bmpx_set_stream_pos)
	self.bmpx.connect_to_signal('SetVolume',     self.bmpx_set_volume)
	self.bmpx.connect_to_signal('TrackChange',     self.bmpx_track_change)

	self.bmpx.SendStatus()

	self.currentVolume = int( self.bmpx.VolumeGet() )

    def bmpx_track_change(self):
	#print str(w)
	#print "EWerWE"
	if self.title != self.bmpx.GetCurrentTitle():
		self.title = self.bmpx.GetCurrentTitle()
		self.onlinetitle =  curses.newwin(1, self.w-12, 0, 0)
		self.onlinetitle.bkgdset(" ", curses.A_REVERSE | curses.A_BOLD)
		self.onlinetitle.idlok(1)
		self.onlinetitle.clear()
		try:
			#self.onlinestatus.clear()
			
			self.onlinetitle.addstr(str(self.title[:self.w-13]))
		except Exception, e:
			print "title",e
		#sleep(5)
		#	pass
		self.onlinetitle.refresh()
	self.trackwin.clear()
	self.trackwin.addstr("Track: "+str(self.bmpx.GetCurrentTrack()+1))
	self.trackwin.refresh()
	#self.build_playlists()
	self.display_playlist( self.bmpx.GetCurrentTracklist())
		
    def bmpx_button_press(self, widget, event):
	    pass
	#if event.type == gtk.gdk._3BUTTON_PRESS:
	    #gtk.main_quit()
	#elif event.type == gtk.gdk.BUTTON_PRESS:
	    #self.windowMain.begin_move_drag(event.button, event.x_root, event.y_root, long(event.time))
    
    def bmpx_volume_changed(self, widget):
	
	volume = int(widget.get_value())
	print volume
	if self.currentVolume != volume:
		self.currentVolume = volume
		#self.s_volume.set_value (volume)
		self.bmpx.VolumeSet (volume)

    def bmpx_play_current(self, widget):
	self.bmpx.PlayCurrent()

    def bmpx_play_next(self, widget):
	self.bmpx.PlayNext()

    def bmpx_play_prev(self, widget):
	self.bmpx.PlayPrev()

    def bmpx_play_pause(self, widget):
	self.bmpx.PlayPause()

    def bmpx_play_stop(self, widget):
	self.bmpx.PlayStop()

    def clear_info(self):
	self.title=""
	self.statusText='STOPPED'
	return 1

    def update_info(self):
	#self.l_title.set_sensitive (1)

	self.uri = self.bmpx.GetCurrentUri()
	self.currentTrack = self.bmpx.GetCurrentTrack()+1
	self.metadata = self.bmpx.GetMetadataForUri(self.uri)
	self.length = int(self.metadata['time'])

	artist = cgi.escape(self.metadata['artist'])
	title = cgi.escape(self.metadata['title'])
	album = cgi.escape(self.metadata['album'])
	artist_s = artist.strip()
	title_s = title.strip()
	album_s = album.strip()

	self.title= '(%d)  %s \'%s\' (%s)' % (self.currentTrack+1, artist_s, title_s, album_s)

	return 1

    def bmpx_set_volume(self, volume):

	self.currentVolume = int(volume)

	self.volwin.clear()
	self.volwin.addstr("Vol: "+str(self.currentVolume))
	self.volwin.refresh()

    def bmpx_set_stream_pos(self, stream_pos):
	minutes = int(stream_pos) / int(60)
	seconds = stream_pos % 60;
	
	minutes_length = int(self.length) / int(60)
	seconds_length = int(self.length) % int(60)

	self.statusnew ='%2.2d:%2.2d / %2.2d:%2.2d' % (minutes, seconds, minutes_length, seconds_length)
	if self.status != self.statusnew:
		self.status = self.statusnew
		try:
			self.onlinetime.clear()
			self.onlinetime.addstr(self.status)
			self.onlinetime.refresh()
		except Exception, e:
			print "Eeeeeeeeee", e

    def bmpx_set_playstatus(self, playstatus):
	#print playstatus
	
	if playstatus == 2:	    #Stopped
	    self.clear_info()
	elif playstatus == 4:	    #Playing
	    self.statusText = 'PLAYING'
	    self.update_info()
	elif playstatus == 8:	    #Paused
	    #self.l_title.set_sensitive (0)
	    self.statusText = 'PAUSED'
	self.onlinestatus =  curses.newwin(1, 10, 0, self.w-10)
	self.onlinestatus.idlok(1)
	#self.onlinestatus.border()
	self.onlinestatus.clear()
	
	try:
		self.onlinestatus.addstr(self.statusText)
		self.onlinestatus.refresh()
	except Exception, e:
		print "Eeeeeeeeee", e
	
	
	return 1
    def run(self):
		self.capturekeys.start()
			
    def build(self, stdscr, line = ""):
		self.stdscr = stdscr
		self.stdscr.clear()
		self.stdscr.refresh()
		self.h, self.w = self.stdscr.getmaxyx()
		#if  self.h >=15 and self.w >=77:
		try:
			
			continue_build = 1
			uri = self.bmpx.GetCurrentUri()
			metadata = self.bmpx.GetMetadataForUri(uri)
			if self.title != self.bmpx.GetCurrentTitle():
				self.title = self.bmpx.GetCurrentTitle()
				continue_build = 1
			self.playlists = self.bmpx.GetPlaylists()

			self.mainowin =  curses.newwin(self.h-1, self.w-15, 1, 0)
			self.mainowin.idlok(1)
			self.mainowin.clear()
			self.mainowin.border()
			self.mainowin.refresh()
			
			self.mainwin =  self.mainowin.subwin(self.h-3, self.w-17, 2, 1)
			self.mainwin.scrollok(1)
			self.mainwin.idlok(1)
			
			
			self.build_playlists()
			
			
			self.instructions =  curses.newwin(2, 14, 4, self.w-15)
			self.instructions.idlok(1)
			self.instructions.clear()
			self.instructions.addstr("Control BMPx\n|z|x|c|v|b|")
			self.instructions.refresh()
			
			self.trackwin =  curses.newwin(1, 14, 3, self.w-15)
			self.trackwin.idlok(1)
			self.trackwin.clear()
			self.trackwin.addstr("Track: "+str(self.bmpx.GetCurrentTrack()+1))
			self.trackwin.refresh()
			
			
			self.volwin =  curses.newwin(1, 14, 2, self.w-15)
			self.volwin.idlok(1)
			self.volwin.clear()
			self.volwin.addstr("Vol: "+str(self.currentVolume))
			self.volwin.refresh()
			
			self.onlinetime =  curses.newwin(1, 14, 1, self.w-15)
			self.onlinetime.idlok(1)
			self.onlinetime.clear()
			
			try:
				self.onlinetime.addstr(self.status)
				self.onlinetime.refresh()
			except Exception, e:
				print "Eeeeeeeeee", e
					
			if continue_build == 1:
				self.onlinetitle =  curses.newwin(1, self.w-11, 0, 0)
				self.onlinetitle.bkgdset(" ", curses.A_REVERSE | curses.A_BOLD)
				self.onlinetitle.idlok(1)
				try:
										
					self.onlinetitle.addstr(str(self.title[:self.w-12]))
				except Exception, e:
					print "title",e
					
				#	pass
				self.onlinetitle.refresh()

				self.editwin = curses.newwin(1, self.w-3, self.h-4, 1)
			
			
		except Exception, e:
			print e
			
		try:
			self.edit = editor(self.editwin, self.escaped, line)
			self.stdscr.nodelay(1)	
		except Exception,e :
			print e
		sleep(0.01)
		
    def build_playlists(self):
	try:
		
		x = 0
		self.playlist_dict = {}
		for playlist in self.playlists:
			self.mainwin.addstr(playlist+"\n")

			t =0
			self.playlist_dict[x] = []
			for track in self.bmpx.GetPlaylist(x):
				ta = str(t+1) # add 1 for zero correction
				while len(ta) <3:
					ta = " "+ta
				tra = "[%s] " % ta # track number
				
				#spit = track.split("/")
				#trackname = spit[-1]
				metadata = self.bmpx.GetMetadataForUri(track)
				length = int(metadata['time'])
				artist = cgi.escape(metadata['artist'])
				title = cgi.escape(metadata['title'])
				trackname = "[%s] %s" % ( artist,  title)
				minutes = int(length)/60
				seconds = str( int(length) - (60 * minutes))
				if len(seconds) < 2:
					seconds = '0' + seconds
				if len(trackname) > self.w-29:
					#self.mainwin.addstr( str(tra)+str(spit[-1][:self.w-24-len(spit[-1])]  )+"\n" )
					#str( length-((length/60)*60))  )
					
					string = str(tra)+str(trackname[:self.w-29-len(trackname)]+" "+str(minutes)+":"+seconds )
					
				else:
					b = str(tra)+str(trackname)
					while len(b) < self.w-22:
						b+=" "
					string = b+str(minutes)+":"+seconds
					
				self.playlist_dict[x].append([t, string])
			
				t +=1
			
			x += 1
		self.display_playlist(self.bmpx.GetCurrentTracklist())

		
	except Exception, e:
		self.mainwin.addstr( "playlist: " + str(e))
	
	
    def display_playlist(self, playlist):
	self.mainwin.clear()
	#self.mainwin.addstr(str(self.playlists))
	playlength = len(self.playlist_dict[playlist])
	for t, string in self.playlist_dict[playlist]:
		#playlength (self.h-3)
		if t < self.bmpx.GetCurrentTrack()-(self.h-3-7):
			if t <  playlength - self.h+3:
				continue
		if t > self.bmpx.GetCurrentTrack()+6:
			if t > playlength -self.h-3:
				break
		if t == self.bmpx.GetCurrentTrack():
			
			try:
				self.mainwin.addstr( string, curses.A_REVERSE )
				self.mainwin.addstr( "\n")
			except:
				pass
			#self.mainwin.refresh()
			#sleep(1)
		else:
			self.mainwin.scrollok(0)
			
			try:
				self.mainwin.addstr( string )
				self.mainwin.addstr( "\n")
			except:
				pass
		
	self.mainwin.refresh()
    def escaped(self, key, line):
		#print key
		if key == "KEY_RESIZE":
			self.stdscr.keypad(1)
			self.build(self.stdscr, line)
		elif key in( "KEY_LEFT", "CC", chr(2),  "KEY_RIGHT", chr(6) ):
			#self.mainwin.addstr( "keys: " + str(key) )
			#self.mainwin.refresh()
			#self.bmpx.Seek()
			#self.bmpx.SetStreamPos()
			pass
		elif key in ("KEY_UP"):#,  "KEY_DOWN", "KEY_PPAGE", "KEY_NPAGE"):
			if self.currentVolume < 100:
				self.bmpx.VolumeSet (self.currentVolume+1)

		elif key in ("KEY_DOWN"):
			if self.currentVolume > 0:
				self.bmpx.VolumeSet (self.currentVolume-1)
		elif key == "r":
			self.build_playlists()
		elif key == "KEY_F(1)":
			#self.chat_mode()
			self.build(self.stdscr, line)
		elif key in ( "z", "Z"):
			if self.bmpx.GetCurrentTrack() != 0:
				self.bmpx.PlayPrev()
		elif key in ( "x", "X"):
			if self.bmpx.GetCurrentTrack() != -1:
				self.bmpx.PlayCurrent()
			else:
				self.bmpx.PlayNext()
		elif key in ( "c", "C"):
			self.bmpx.PlayPause()
		elif key in ( "v", "V"):
			self.bmpx.PlayStop()
		elif key in ( "b", "B"):
			#print self.bmpx.GetCurrentTrack() 
			#self.mainwin.addstr( "\nkeys: " + str(self.bmpx.GetCurrentTrack()) )
			#self.mainwin.refresh()
			self.bmpx.PlayNext()
	
class editor:
	def __init__(self, win, escaped, line = ""):
		self.win = win
		self.escaped = escaped
		self.h, self.w = win.getmaxyx()
		self.scroll = 0
		
		self.line = line
		self.x = len(self.line)
		#self.fixpos()
		self.escape = False
		self.y = None

		

	def process(self, c):
		#pos = self.x + self.scroll
		
		# debugging: display keypress
		#print c
		if c in ('z', 'Z','x','X','c', 'v','V','b'):
			#BMPMonitor.bmpx.PlayPrev()
			self.escaped(c, self.line)
		elif c == chr(10) or c == "KEY_ENTER":
			self.escape = False
			self.escaped(c, self.line)
		elif c == "KEY_LEFT" or c == chr(2) or c == "KEY_RIGHT" or c == chr(6):
			if self.escape:
				self.escaped(c, self.line)
		elif c in ("KEY_F(1)"):
			self.escaped(c, self.line)
		elif c in ("KEY_UP", "KEY_DOWN", "KEY_F(1)"):
			if self.escape:
				self.escaped(c, self.line)
		elif c in ("r"):
			if self.escape:
				self.escaped(c, self.line)
		elif c == chr(27):
			self.escape = True
			return False
		else: 
			return False
		#self.fixpos()
		self.escape = False
		return False


	def reset(self):
		self.x = self.scroll = 0
		self.line = ""

		#self.win.erase()
		self.win.refresh()
			
class MainApp:
	def __init__(self):
		self.stdscr = curses.initscr()
		curses.curs_set(0)
		curses.start_color()
		curses.noecho()
		self.stdscr.keypad(1)
		
		curses.mousemask(curses.BUTTON1_CLICKED)
		curses.mouseinterval(110)
		self.app = BMPMonitor()
		
	def MainLoop(self):

		signal.signal(signal.SIGINT, signal.SIG_DFL)

		
		#self.app.MutrayWindow.show()
		self.app.build(self.stdscr, line)
		
		Mapp.app.capturekeys.start()
		gtk.gdk.threads_enter()
		gtk.main()
		gtk.gdk.threads_leave()
		
gobject.threads_init()
#c = BMPMonitor()
Mapp = MainApp()

line = ""

try:
	first_run=1
	#while 1:
	#if 1:

	Mapp.MainLoop()

	try:
		curses.noecho()
	except:
		pass
	try:
		curses.cbreak()
	except:
		pass

	sleep(0.01)

except Exception, e:
	try:
		curses.nocbreak()
		Mapp.stdscr.keypad(0)
		curses.echo()
		curses.endwin()
	except:
		pass

	print "main:", e
curses.nocbreak()
Mapp.stdscr.keypad(0)
curses.echo()
curses.endwin()
