#!/bin/bash

export TEMPLATE_C=g_object_get.in.c
export TEMPLATE_H=g_object_get.in.h
export TYPES=g_object_get.types

rm -f g_object_get.c
rm -f g_object_get.h

echo "#include <g_object_get.h>"    >> g_object_get.c
echo "#include <glib-object.h>"     >> g_object_get.c

echo "#ifndef __AUX_G_OBJECT_GET_H" >> g_object_get.h 
echo "#define __AUX_G_OBJECT_GET_H" >> g_object_get.h 

echo "#include <glib-object.h>"     >> g_object_get.h

for Line in `cat $TYPES`; do

   export G_TYPE=`echo $Line|cut -d: -f1`
   export C_TYPE=`echo $Line|cut -d: -f2`
   export   NAME=`echo $Line|cut -d: -f3`
   export   RVAL=`echo $Line|cut -d: -f4`

   cat $TEMPLATE_C | sed s:\@TYPE_CTYPE\@:$C_TYPE:g \
                   | sed s:\@TYPE_GTYPE_BASE\@:$G_TYPE:g \
                   | sed s:\@TYPE_GTYPE_FULL\@:G_TYPE_$G_TYPE:g \
                   | sed s:\@NAME\@:$NAME:g \
                   | sed s:\@RVAL\@:$RVAL:g \
                   >> g_object_get.c
   
   cat $TEMPLATE_H | sed s:\@TYPE_CTYPE\@:$C_TYPE:g \
                   | sed s:\@TYPE_GTYPE_BASE\@:$G_TYPE:g \
                   | sed s:\@TYPE_GTYPE_FULL\@:G_TYPE_$G_TYPE:g \
                   | sed s:\@NAME\@:$NAME:g \
                   | sed s:\@RVAL\@:$RVAL:g \
                   >> g_object_get.h
done

echo "#endif /*__AUX_G_OBJECT_GET_H*/"  >> g_object_get.h

