#ifndef __LIST_H_
#define __LIST_H_

#define LIST_GET_COLUMN_DATA(list,item,column_idx)\
	list->column_data_func(item,column_idx)

#define LIST_GET_NTH_ITEM(list,row_idx) \
	g_list_nth(list->items,row_idx)->data

#define LIST_GET_NTH_ITEM_GLIST(list,row_idx) \
	g_list_nth(list->items,row_idx)

#define LIST_ADD_ITEM(list,item) \
	list->items = g_list_append(list->items,item)

#define LIST_ADD_ITEM_POSITION(list,item,_idx) \
	list->items = g_list_insert(list->items,item,_idx)

#define LIST_REMOVE_ITEM(list,_idx) \
	list->items = g_list_remove(list->items, g_list_nth(list->items, _idx)->data)

#define LAST_SELECTED_NONE -1

typedef gchar*    (*ColumnDataFunc)      (gpointer item, gint column_idx);
typedef gboolean  (*RowGetSelectedFunc)  (gpointer item);
typedef void      (*RowSetSelectedFunc)  (gpointer item, gboolean selected);
typedef void      (*ListSortFunc)        (gconstpointer data1, gconstpointer data2);
typedef void      (*OnDisplayFunc)       (gpointer item);
typedef void      (*ItemSwapFunc)        (GList    *items, gint _idx1, gint _idx2);
typedef void      (*CurrentSetFunc)      (gpointer item, gboolean current);
typedef void      (*SetDirtyFunc)        (gpointer item, gboolean current);
typedef gboolean  (*GetDirtyFunc)        (gpointer item);
typedef void      (*SetRenderedFunc)     (gpointer item, gboolean rendered);
typedef gboolean  (*GetRenderedFunc)     (gpointer item);

typedef struct _BmpListType BmpListType;

struct _BmpListType {
	gchar	    *name;
	GList       *items;
	GList	    *items_shuffle;

	gint         current;
	gint	     current_linear;
	gint	     last_selected;
	gboolean     multiple_selected;

	gdouble	     adjustment;

	ColumnDataFunc     column_data_func;

	RowGetSelectedFunc row_get_selected_func;
	RowSetSelectedFunc row_set_selected_func;
	ListSortFunc	   list_sort_func;
        ItemSwapFunc       item_swap_func;

	OnDisplayFunc	   on_display_func;

	SetDirtyFunc	   set_dirty_func;
	GetDirtyFunc	   get_dirty_func;

	SetRenderedFunc	   set_rendered_func;
	GetRenderedFunc	   get_rendered_func;

	GDestroyNotify  item_destroy_func;
};

#define BMP_LIST(list) ((BmpListType *) list)

#endif /* __LIST_H_ */
