/*  BMPx - The Dumb Music Player
 *  Copyright (C) 2005 BMPx development team.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  $Id$
 */

#include <glib.h>
#include <glib/gi18n.h>
#include <gtk/gtk.h>


#define GLIB_REQUIRED_MAJOR_VER GLIB_MAJOR_VERSION
#define GLIB_REQUIRED_MINOR_VER 8
#define GLIB_REQUIRED_MICRO_VER 0

#define GTK_REQUIRED_MAJOR_VER GTK_MAJOR_VERSION
#define GTK_REQUIRED_MINOR_VER 8
#define GTK_REQUIRED_MICRO_VER 0

#define GLADE_REQUIRED_MAJOR_VER GLIB_MAJOR_VERSION
#define GLADE_REQUIRED_MINOR_VER 8
#define GLADE_REQUIRED_MICRO_VER 0


static gchar *
sanity_check_glib (void)
{
  if (glib_check_version (GLIB_REQUIRED_MAJOR_VER,
                          GLIB_REQUIRED_MINOR_VER,
                          GLIB_REQUIRED_MICRO_VER))
    {
      return g_strdup_printf (Q_("BMPx requires Glib %d.%d.%d or above to run."),
                              GLIB_REQUIRED_MAJOR_VER,
                              GLIB_REQUIRED_MINOR_VER,
                              GLIB_REQUIRED_MICRO_VER);
    }

  return NULL;
}

static gchar *
sanity_check_gtk (void)
{
  if (gtk_check_version (GTK_REQUIRED_MAJOR_VER,
                         GTK_REQUIRED_MINOR_VER,
                         GTK_REQUIRED_MICRO_VER))
    {
      return g_strdup_printf (Q_("BMPx requires GTK+ %d.%d.%d or above to run."),
                              GTK_REQUIRED_MAJOR_VER,
                              GTK_REQUIRED_MINOR_VER,
                              GTK_REQUIRED_MICRO_VER);
    }

  return NULL;
}

gchar *
sanity_check_libs (void)
{
  gchar *error;

  if ((error = sanity_check_glib ()) != NULL)
    {
      return error;
    }

  if ((error = sanity_check_gtk ()) != NULL)
    return error;

  return NULL;
}
